package se.chalmers.tdv.test;

import static org.junit.Assert.assertArrayEquals;

import org.junit.Before;
import org.junit.Test;

import se.chalmers.tdv.ExTwo;

public class ExTwoTest {

	static Float[] a;

	@Before
	public void setUp() throws Exception {
		// Necessary. See what goes wrong if we initialise in the declaration of
		// the field a instead.

		// Footnote: initialising in the declaration would work if the field was
		// not declared static.
		a = new Float[] { 1.0f, 2.0f };

	}

	@Test
	public final void testVector_addEmpty() {
		// If you check for coverage with ElcEmma you can get 100% by
		// uncommenting this line:

		// ExTwo e = new ExTwo();
		Float[] a = new Float[] {};
		Float[] b = new Float[] {};
		ExTwo.vector_add(a, b);
		assertArrayEquals(a, new Float[] {});
		assertArrayEquals(b, new Float[] {});
	}

	@Test
	public final void testVector_addEmptyNonEmptyOne() {
		Float[] b = new Float[] { 1.0f, 1.0f };
		ExTwo.vector_add(a, b);
		assertArrayEquals(a, new Float[] { 2.0f, 3.0f });
		assertArrayEquals(b, new Float[] { 1.0f, 1.0f });
	}

	@Test
	public final void testVector_addEmptyNonEmptyTwo() {
		Float[] b = new Float[] { 1.0f, 2.0f };
		ExTwo.vector_add(a, b);
		assertArrayEquals(a, new Float[] { 2.0f, 4.0f });
		assertArrayEquals(b, new Float[] { 1.0f, 2.0f });
	}

}
